module image_processing(VGA_CLK,
								SW,
								datain_x0y0,
								datain_x1y0,
								datain_x2y0,
								datain_x0y1,
								datain_x1y1,
								datain_x2y1,
								datain_x0y2,
								datain_x1y2,
								datain_x2y2,
								RGB_out);
input VGA_CLK;
input [3:0]SW;
input [29:0]datain_x0y0;
input [29:0]datain_x1y0;
input [29:0]datain_x2y0;
input [29:0]datain_x0y1;
input [29:0]datain_x1y1;
input [29:0]datain_x2y1;
input [29:0]datain_x0y2;
input [29:0]datain_x1y2;
input [29:0]datain_x2y2;
output reg [29:0]RGB_out;

//reg [9:0]red_channel		=	(datain_x0y0[29:20]+datain_x1y0[29:20]+datain_x2y0[29:20]+datain_x0y1[29:20]+datain_x1y1[29:20]+datain_x2y1[29:20]+datain_x0y2[29:20]+datain_x1y2[29:20]+datain_x2y2[29:20])/9;
//reg [9:0]green_channel 	= 	(datain_x0y0[19:10]+datain_x1y0[19:10]+datain_x2y0[19:10]+datain_x0y1[19:10]+datain_x1y1[19:10]+datain_x2y1[19:10]+datain_x0y2[19:10]+datain_x1y2[19:10]+datain_x2y2[19:10])/9;
//reg [9:0]blue_channel 		= 	(datain_x0y0[9:0]+datain_x1y0[9:0]+datain_x2y0[9:0]+datain_x0y1[9:0]+datain_x1y1[9:0]+datain_x2y1[9:0]+datain_x0y2[9:0]+datain_x1y2[9:0]+datain_x2y2[9:0])/9;

reg [20:0]x=0;
reg [20:0]y=0;
reg [20:0]z=0;
reg [20:0]w=0;
reg [29:0]gray;
/*your hardware description */
always@(negedge VGA_CLK)
begin
	case(SW[3:0])
4'd0:RGB_out[29:0]<={datain_x0y0[29:20],20'd0};
4'd1:RGB_out[29:0]<={10'd0,datain_x0y0[19:10],10'd0};
4'd2:RGB_out[29:0]<={20'd0,datain_x0y0[9:0]};
4'd3:RGB_out[29:0] <= {datain_x0y0[29:20],datain_x0y0[29:20],datain_x0y0[29:20]};
4'd4:RGB_out[29:0] <= {datain_x0y0[19:10],datain_x0y0[19:10],datain_x0y0[19:10]};
4'd5:RGB_out[29:0] <= {datain_x0y0[9:0],datain_x0y0[9:0],datain_x0y0[9:0]};
4'd6:	begin
		x[9:0]<=((datain_x0y0[29:20]*299)/1000);
		y[9:0]<=((datain_x0y0[19:10]*587)/1000);
		z[9:0]<=(datain_x0y0[9:0]*114/1000);
		w[9:0]<=x[9:0]+y[9:0]+z[9:0];
		RGB_out[29:0] <= {w[9:0],w[9:0],w[9:0]};
		end 
4'd7:	begin
		RGB_out[29:0] <= ~{datain_x0y0[29:20],datain_x0y0[19:10],datain_x0y0[9:0]};
		end
		/////////////////
4'd8:	begin
		x[9:0]<=(datain_x0y0[29:20]);
		y[9:0]<=(datain_x0y0[19:10]*95/100);
		z[9:0]<=(datain_x0y0[9:0]*82/100);
		RGB_out[29:0] <= {x[9:0],y[9:0],z[9:0]};
		end
4'd9:	begin
		x[9:0]<=((datain_x2y0[29:0]+(2*datain_x2y1[29:0])+datain_x2y2[29:0])-(datain_x0y0[29:0]+(2*datain_x0y1[29:0])+datain_x0y2[29:0]));
		y[9:0]<=((datain_x0y0[29:0]+(2*datain_x1y0[29:0])+datain_x2y0[29:0])-(datain_x0y2[29:0]+(2*datain_x1y2[29:0])+datain_x2y2[29:0]));
		if(x[9]==0 && y[9]==0)begin w[10:0]<= ((x[9:0])+(y[9:0])); end 
		else begin
					if(x[9]==0 && y[9]==1)begin w[10:0]<= ((x[9:0])+(~y[9:0])); end 
					else begin
									if(x[9]==1 && y[9]==0)begin w[10:0]<= ((~x[9:0])+(y[9:0])); end 
									else begin
									if(x[9]==1 && y[9]==1)begin w[10:0]<= ((~x[9:0])+(~y[9:0])); end
											end
							end 
				end
		RGB_out[29:0] <= {w[9:0],w[9:0],w[9:0]};
		end
4'd10:begin
		gray[9:0]<={((datain_x0y0[29:20]) + (datain_x0y0[19:10]) + (datain_x0y0[9:0]))/3};
		w[9:0]<={((datain_x0y0[29:20]) + (datain_x0y1[29:20]) + (datain_x0y2[29:20])+(datain_x1y0[29:20]) + (datain_x1y2[29:20])+(datain_x2y0[29:20]) + (datain_x2y1[29:20]) + (datain_x2y2[29:20]))/8};
		if(w[9:0]>720) begin x[9:0] <= datain_x0y0[29:20];end else  begin x[9:0] <= gray[9:0]; end
		if(w[9:0]>720) begin y[9:0] <= datain_x0y0[19:10];end else  begin y[9:0] <= gray[9:0]; end
		if(w[9:0]>720) begin z[9:0] <= datain_x0y0[9:0];end else  begin z[9:0] <= gray[9:0]; end
		RGB_out[29:0] <= {x[9:0],y[9:0],z[9:0]};
		end
4'd11:begin
		gray[9:0]<=((datain_x0y0[29:20]*299)/1000)+((datain_x0y0[19:10]*587)/1000)+(datain_x0y0[9:0]*114/1000);
		if(datain_x0y0[19:10]>620) begin x[9:0] <= datain_x0y0[29:20];end else  begin x[9:0] <= gray[9:0]; end
		if(datain_x0y0[19:10]>620) begin y[9:0] <= datain_x0y0[19:10];end else  begin y[9:0] <= gray[9:0]; end
		if(datain_x0y0[19:10]>620) begin z[9:0] <= datain_x0y0[9:0];end else  begin z[9:0] <= gray[9:0]; end
		RGB_out[29:0] <= {x[9:0],y[9:0],z[9:0]};
		end 
4'd12:begin
		gray[9:0]<={(datain_x0y0[29:20]>>2) + (datain_x0y0[19:10]>>2) + (datain_x0y0[9:0]>>2)};
		if(datain_x0y0[9:0]>620) begin x[9:0] <= datain_x0y0[29:20];end else  begin x[9:0] <= gray[9:0]; end
		if(datain_x0y0[9:0]>620) begin y[9:0] <= datain_x0y0[19:10];end else  begin y[9:0] <= gray[9:0]; end
		if(datain_x0y0[9:0]>620) begin z[9:0] <= datain_x0y0[9:0];end else  begin z[9:0] <= gray[9:0]; end
		RGB_out[29:0] <= {x[9:0],y[9:0],z[9:0]};
		end
4'd13:begin
		gray[9:0]<={((datain_x0y0[29:20]) + (datain_x0y1[19:10]) + (datain_x0y2[9:0])+(datain_x1y0[29:20]) + (datain_x1y2[9:0])+(datain_x2y0[29:20]) + (datain_x2y1[19:10]) + (datain_x2y2[9:0]))/8};
		if(gray[9:0]>620) begin x[9:0] <= 10'd0; end else  begin x[9:0] <= 10'h3ff; end
		if(gray[9:0]>620) begin y[9:0] <= 10'd0;end else  begin y[9:0] <= 10'h3ff; end
		if(gray[9:0]>620) begin z[9:0] <= 10'd0;end else  begin z[9:0] <= 10'h3ff; end
		RGB_out[29:0] <= {x[9:0],y[9:0],z[9:0]};
		end
4'd14:begin
		x[9:0]<={((datain_x0y0[29:20]*168/1000) + (datain_x0y0[19:10]*331/1000) + (datain_x0y0[9:0]/2))};
		z[9:0]<={((datain_x0y0[29:20]/2) + (~datain_x0y0[19:10]*418/1000) + (~datain_x0y0[9:0]*81/1000))};
	//	if(x[9:0]>85 && x[9:0]<135 && y[9:0]>135 && y[9:0]<180) begin
	if(x[9:0]>=10 ) begin
																					x[9:0] <= datain_x0y0[29:20];
																					y[9:0] <= datain_x0y0[19:10];
																					z[9:0] <= datain_x0y0[9:0];
																					end 
																					else  begin
																					x[9:0] <= 10'h0;
																					y[9:0] <= 10'd0;
																					z[9:0] <= 10'd0;	
																					end
		
		RGB_out[29:0] <= {x[9:0],y[9:0],z[9:0]};
		end		
	default :RGB_out[29:0]<=datain_x0y0[29:0];
	endcase
end
 	

endmodule
