module image_processing(VGA_CLK,
								SW,
								datain_x0y0,
								datain_x1y0,
								datain_x2y0,
								datain_x0y1,
								datain_x1y1,
								datain_x2y1,
								datain_x0y2,
								datain_x1y2,
								datain_x2y2,
								RGB_out);
input VGA_CLK;
input [4:0]SW;
input [29:0]datain_x0y0;
input [29:0]datain_x1y0;
input [29:0]datain_x2y0;
input [29:0]datain_x0y1;
input [29:0]datain_x1y1;
input [29:0]datain_x2y1;
input [29:0]datain_x0y2;
input [29:0]datain_x1y2;
input [29:0]datain_x2y2;
output [29:0]RGB_out;



wire [9:0]rrsepia=(datain_x0y0[29:20]*100)/100;
wire [9:0]ggsepia=(datain_x0y0[19:10]*95)/100;
wire [9:0]bbsepia=(datain_x0y0[9:0]*82)/100;

wire[19:0]lumir=(datain_x0y0[29:20]*30);
wire[19:0]lumig=(datain_x0y0[19:10]*60);
wire[19:0]lumib=(datain_x0y0[9:0]*11);
wire[16:0]lumin=(lumir[19:0]+lumig[19:0]+lumib[19:0]);


reg [39:0]Gx=0;
reg [39:0]Gy=0;


/*your hardware description */
	//promedio suma de las paletas RGB de los nueve bits sobre 9
	//assign RGB_out[29:0]=(datain_x0y0[29:0]+datain_x1y0[29:0]+datain_x2y0[29:0]+datain_x0y1[29:0]+datain_x1y1[29:0]+datain_x2y1[29:0]+datain_x0y2[29:0]+datain_x1y2[29:0]+datain_x2y2[29:0])/9;
//wire [38:0]prom=(datain_x0y0[29:0]/9)+(datain_x1y0[29:0]/9)+(datain_x2y0[29:0]/9)+(datain_x0y1[29:0]/9)+(datain_x1y1[29:0]/9)+(datain_x2y1[29:0]/9)+(datain_x0y2[29:0]/9)+(datain_x1y2[29:0]/9)+(datain_x2y2[29:0]/9);	
wire [9:0]prom=((datain_x0y0[29:0])+(datain_x1y0[29:0])+(datain_x2y0[29:0])+(datain_x0y1[29:0])+(datain_x2y1[29:0])+(datain_x0y2[29:0])+(datain_x1y2[29:0])+(datain_x2y2[29:0]))/8;	
wire [9:0]gris=(datain_x0y0[29:20] >> 2) + (datain_x0y0[19:10] >> 2) + (datain_x0y0[9:0] >> 2);

//para tresholding skin detection se pasa a escala YUV (Thu thao nguyen cornel)
// con 10bits color depth el rango U cae entre 40<U<296
wire [9:0]Y=(datain_x0y0[29:20]+(2*datain_x0y0[19:10])+datain_x0y0[9:0])/4;
wire [9:0]U=datain_x0y0[29:20]-datain_x0y0[19:10];
wire [9:0]V=datain_x0y0[9:0]-datain_x0y0[19:10];
//wire [29:0]skin= (40<U && U<296)? {10'd685,10'd685,10'd685}:30'd0;
wire [29:0]skin= (40<U && U<296)? {datain_x0y0[29:0]}:30'd0;

reg [29:0]skinr;
reg [2:0]countskin=0;
reg [2:0]countimes=0;


//assign RGB_out[29:0]=datain_x0y0[29:0];
	assign RGB_out[29:0]=(SW[4:0]==5'd0)?{datain_x0y0[29:20],20'd0}://componente R
								(SW[4:0]==5'd1)?{10'd0,datain_x0y0[19:10],10'd0}:// componente G
								(SW[4:0]==5'd2)?{20'd0,datain_x0y0[9:0]}://componente B
								(SW[4:0]==5'd3)?{datain_x0y0[29:20],datain_x0y0[29:20],datain_x0y0[29:20]}://Escala de grises basado en R
								(SW[4:0]==5'd4)?{datain_x0y0[19:10],datain_x0y0[19:10],datain_x0y0[19:10]}://Escala de grises basado en G
								(SW[4:0]==5'd5)?{datain_x0y0[9:0],datain_x0y0[9:0],datain_x0y0[9:0]}://Escala de grises basado en B
								(SW[4:0]==5'd6)?{lumin[16:7],lumin[16:7],lumin[16:7]}:
								(SW[4:0]==5'd7)?{~datain_x0y0[29:20],~datain_x0y0[19:10],~datain_x0y0[9:0]}://Negativ
								(SW[4:0]==5'd8)?{rrsepia[9:0],ggsepia[9:0],bbsepia[9:0]}://sepia
//								(SW[4:0]==5'd9)?(Gnn[40:0]>41'd536870912)? {10'd685,10'd1685,10'd685}: {10'd95,10'd95,10'd95} ://Sobel
								(SW[4:0]==5'd9)? {Gn[9:0],Gn[9:0],Gn[9:0]}:
//  							(SW[4:0]==5'd9)?{Gnn[10:0],Gnn[10:0],Gnn[10:0]}://Sobel
//								(SW[4:0]==5'd10)? (datain_x0y0[29:20]<800)?{gris[9:0],gris[9:0],gris[9:0]}:datain_x0y0[29:0]:
								(SW[4:0]==5'd10)? (datain_x0y0[29:20]<550)?{lumin[16:7],lumin[16:7],lumin[16:7]}:datain_x0y0[29:0]:
								(SW[4:0]==5'd11)? (datain_x0y0[19:10]<550)?{lumin[16:7],lumin[16:7],lumin[16:7]}:datain_x0y0[29:0]:
								(SW[4:0]==5'd12)? (datain_x0y0[9:0]<550)?{lumin[16:7],lumin[16:7],lumin[16:7]}:datain_x0y0[29:0]:
//								(SW[4:0]==5'd13)? (prom[30:0]>31'd390)? {10'd685,10'd685,10'd685}:{10'd95,10'd95,10'd95}: //390 para promedio
								(SW[4:0]==5'd13)? (prom[9:0]>10'd620)? {10'd685,10'd1685,10'd685}:30'd0: //390 para promedio
								(SW[4:0]==5'd14)? skin[29:0]:
//								{10'd95,10'd95,10'd95}
								datain_x0y0[29:0];
	reg [40:0]Gn=0;
//	reg [40:0]Gnn=0;
//	reg [30:0]Gnnn=0;

//reg [32:0]ax;
//reg [32:0]bx;
//reg [32:0]ay;
//reg [32:0]by;
//reg [39:0]fp_delay[2399:0];
//reg [39:0]fp1_delay[2399:0];
//genvar index;
//	generate 
////		for (index=1;index<2399;index=index+1)//800 display horiz
//		for (index=1;index<799;index=index+1)
//		begin: generate_delaybuff
//			always@(posedge VGA_CLK)
//			begin
//			fp_delay[0][39:0]<=Gx[39:0];
//			fp_delay[index][39:0]<=fp_delay[index-1][39:0];
//			fp1_delay[0][39:0]<=Gy[39:0];
//			fp1_delay[index][39:0]<=fp1_delay[index-1][39:0];
//			end
//		end
//	endgenerate

always@(*)
	begin

	
		Gx[9:0]=(datain_x2y0[29:0])+(2*datain_x2y1[29:0])+(datain_x2y2[29:0])-(datain_x0y0[29:0])-(2*datain_x0y1[29:0])-(datain_x0y2[29:0]);
		Gy[9:0]=(datain_x0y0[29:0])+(datain_x1y0[29:0]*2)+(datain_x2y0[29:0])-(datain_x0y2[29:0])-(2*datain_x1y2[29:0])-(datain_x2y2[29:0]);
		
		
//		if(Gx[39:0]>=0 && Gy[39:0]>=0) Gn[40:0]=Gx[39:0]+Gy[39:0]; //valor absoluto
//		else if(Gx[39:0]<0 && Gy[39:0]>=0)Gn[40:0]=(~Gx[39:0])+Gy[39:0];
//		else if(Gx[39:0]>=0 && Gy[39:0]<0)Gn[40:0]=Gx[39:0]+(~Gy[39:0]);
//		else Gn[40:0]=(~Gx[39:0])+(~Gy[39:0]);
		
		if(Gx[9]==0 && Gy[9]==0) Gn[10:0]=Gx[9:0]+Gy[9:0]; //valor absoluto
		else if(Gx[9]==1 && Gy[9]==0)Gn[10:0]=(~Gx[9:0])+Gy[9:0];
		else if(Gx[9]==0 && Gy[9]==1)Gn[10:0]=Gx[9:0]+(~Gy[9:0]);
		else Gn[10:0]=(~Gx[9:0])+(~Gy[9:0]);
		
		
//		if(fp_delay[799][39:0]>=0 && fp1_delay[799][39:0]>=0) Gn[40:0]=fp_delay[799][39:0]+fp1_delay[799][39:0]; //valor absoluto
//		else if(fp_delay[799][39:0]<0 && fp1_delay[799][39:0]>=0)Gn[40:0]=(fp_delay[799][39:0]*-1)+fp1_delay[799][39:0];
//		else if(fp_delay[799][39:0]>=0 && fp1_delay[799][39:0]<0)Gn[40:0]=fp_delay[799][39:0]+(fp1_delay[799][39:0]*-1);
//		else Gn[40:0]=(fp_delay[799][39:0]*-1)+(fp1_delay[799][39:0]*-1);

	end

endmodule
