module promedio_cuadro(R,G,B,clk,x_inicial,y_inicial,x_final,y_final,x_real,y_real,promedio,reset);
input [7:0]R;
input [7:0]G;
input [7:0]B;
input clk;
input reset;
input [10:0]x_real;
input [9:0]y_real;



wire [23:0]prome_R;
wire [23:0]prome_G;
wire [23:0]prome_B;

input [10:0]x_inicial;
input [9:0]y_inicial;
input [10:0]x_final;
input [9:0]y_final;
output [23:0]promedio;

reg [23:0]dataR;
reg [23:0]dataG;
reg [23:0]dataB;
reg [15:0]contador;
wire cuente=(x_real[10:0]>=x_inicial[10:0] && y_real[9:0]>=y_inicial[9:0] && x_real[10:0]<=x_final[10:0] && y_real[9:0]<=y_final[9:0])?1:0;
wire finish =  (x_real[10:0]==x_final[10:0] && y_real[9:0]==y_final[9:0])?1:0;

reg [7:0]promR;
reg [7:0]promG;
reg [7:0]promB;

assign promedio[23:0]={promR[7:0],promG[7:0],promB[7:0]};

always@(posedge clk , negedge reset)
begin
	if (~reset)
	begin
		contador[15:0] <= 16'd0;
		dataR[23:0]<=24'b0;	
		dataG[23:0]<=24'b0;
		dataB[23:0]<=24'b0;
		promR[7:0]<=8'd0;
		promG[7:0]<=8'd0;
		promB[7:0]<=8'd0;
	end
	else
	begin
		 if(finish)
		begin
			contador[15:0] <= 16'd0;
			promR[7:0]<=prome_R[7:0];
			promG[7:0]<=prome_G[7:0];
			promB[7:0]<=prome_B[7:0];
			dataR[23:0]<=24'b0;	
			dataG[23:0]<=24'b0;
			dataB[23:0]<=24'b0;
		end
		else if(cuente)	
		begin
			promR[7:0]<=promR[7:0];
			promG[7:0]<=promG[7:0];
			promB[7:0]<=promB[7:0];
			contador[15:0]<=contador[15:0]+1'b1;
			dataR[23:0]<=dataR[23:0]+R[7:0];	
			dataG[23:0]<=dataG[23:0]+G[7:0];
			dataB[23:0]<=dataB[23:0]+B[7:0];
		end
		else
		begin
			promR[7:0]<=promR[7:0];
			promG[7:0]<=promG[7:0];
			promB[7:0]<=promB[7:0];
			contador[15:0]<=contador[15:0];
			dataR[23:0]<=dataR[23:0];	
			dataG[23:0]<=dataG[23:0];
			dataB[23:0]<=dataB[23:0];
		end
	end
end	

div_module	div_module_instR (
	.denom (contador[15:0]),
	.numer (dataR[23:0]),
	.quotient (prome_R[23:0]),
	.remain ()
	);
	
div_module	div_module_instG (
	.denom (contador[15:0]),
	.numer (dataG[23:0]),
	.quotient (prome_G[23:0]),
	.remain ()
	);
div_module	div_module_instB (
	.denom (contador[15:0]),
	.numer (dataB[23:0]),
	.quotient (prome_B[23:0]),
	.remain ()
	);
endmodule
	